require_relative 'resource'

module Heroix
  class Client < Resource
    def users
      build_resource :users, :user
    end

    def session
      build_resource :session, :session
    end

    def organisations
      build_resource :organisations, :organisation
    end

    def beneficiaries
      build_resource :beneficiaries, :beneficiary
    end

    def beneficiary_registrations
      build_resource :beneficiary_registrations, :beneficiary_registration
    end

    def beneficiary_rules
      build_resource :beneficiary_rules, :beneficiary_rule
    end

    def campaigns
      build_resource :campaigns, :campaign
    end

    def campaign_peer_to_peers
      build_resource :campaign_peer_to_peers, :campaign_peer_to_peer
    end

    def organisation_beneficiaries
      build_resource :organisation_beneficiaries, :organisation_beneficiary
    end

    def campaign_beneficiaries
      build_resource :campaign_beneficiaries, :campaign_beneficiary
    end

    def microsites
      build_resource :microsites, :microsite
    end

    def microsite_pages
      build_resource :microsite_pages, :microsite_page
    end

    def search(type, params)
      build_resource("search/#{type}", type).index(params)
    end

    private

    def build_resource(path, type)
      Resource.new :url => url_for(path),
                   :token => token,
                   :type => type
    end
  end
end
